<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 3.2 Final//EN">

<!--Converted with jLaTeX2HTML 2002 (1.62) JA patch-1.4
patched version by:  Kenshi Muto, Debian Project.
LaTeX2HTML 2002 (1.62),
original version by:  Nikos Drakos, CBLU, University of Leeds
* revised and updated by:  Marcus Hennecke, Ross Moore, Herb Swan
* with significant contributions from:
  Jens Lippmann, Marek Rouchal, Martin Wilck and others -->
<HTML>
<HEAD>
<TITLE>PVFS2 High-Availability Clustering using Heartbeat 2.0</TITLE>
<META NAME="description" CONTENT="PVFS2 High-Availability Clustering using Heartbeat 2.0">
<META NAME="keywords" CONTENT="pvfs2-ha-heartbeat-v2">
<META NAME="resource-type" CONTENT="document">
<META NAME="distribution" CONTENT="global">

<META HTTP-EQUIV="Content-Type" CONTENT="text/html; charset=iso-8859-1">
<META NAME="Generator" CONTENT="jLaTeX2HTML v2002 JA patch-1.4">
<META HTTP-EQUIV="Content-Style-Type" CONTENT="text/css">

<LINK REL="STYLESHEET" HREF="pvfs2-ha-heartbeat-v2.css">

<? include("../../../../header.php"); ?></HEAD>

<?include("../../../..//top.php"); ?> <body id="documentation">



<table width="95%" class="tabletype1" cellpadding="0" cellspacing="0" align="left">
<tr>
<td>
<table width="100%" cellspacing="0" cellpadding="1">
<tr>                                                          
<td class="nav_white" width="70%" valign="top">               
<br>

<table cellspacing="0" cellpadding="1" align="left" width="70%">
<tr>
<td width="80%" valign="top">

<P>
<H1 ALIGN="LEFT">PVFS2 High-Availability Clustering using Heartbeat 2.0</H1>
<P ALIGN="LEFT"><STRONG>2007</STRONG></P>

<P>
<BR>

<H2><A NAME="SECTION00010000000000000000">
Contents</A>
</H2>
<!--Table of Contents-->

<UL>
<LI><A NAME="tex2html35"
  HREF="pvfs2-ha-heartbeat-v2.php">1 Introduction</A>
<LI><A NAME="tex2html36"
  HREF="pvfs2-ha-heartbeat-v2.php#SECTION00030000000000000000">2 Requirements</A>
<UL>
<LI><A NAME="tex2html37"
  HREF="pvfs2-ha-heartbeat-v2.php#SECTION00031000000000000000">2.1 Hardware</A>
<LI><A NAME="tex2html38"
  HREF="pvfs2-ha-heartbeat-v2.php#SECTION00032000000000000000">2.2 Software</A>
<LI><A NAME="tex2html39"
  HREF="pvfs2-ha-heartbeat-v2.php#SECTION00033000000000000000">2.3 Network</A>
</UL>
<BR>
<LI><A NAME="tex2html40"
  HREF="pvfs2-ha-heartbeat-v2.php#SECTION00040000000000000000">3 Configuring PVFS2</A>
<LI><A NAME="tex2html41"
  HREF="pvfs2-ha-heartbeat-v2.php#SECTION00050000000000000000">4 Configuring storage</A>
<LI><A NAME="tex2html42"
  HREF="pvfs2-ha-heartbeat-v2.php#SECTION00060000000000000000">5 Distributing Heartbeat scripts</A>
<LI><A NAME="tex2html43"
  HREF="pvfs2-ha-heartbeat-v2.php#SECTION00070000000000000000">6 Base Heartbeat configuration</A>
<LI><A NAME="tex2html44"
  HREF="pvfs2-ha-heartbeat-v2.php#SECTION00080000000000000000">7 CIB configuration</A>
<UL>
<LI><A NAME="tex2html45"
  HREF="pvfs2-ha-heartbeat-v2.php#SECTION00081000000000000000">7.1 crm_config</A>
<LI><A NAME="tex2html46"
  HREF="pvfs2-ha-heartbeat-v2.php#SECTION00082000000000000000">7.2 nodes</A>
<LI><A NAME="tex2html47"
  HREF="pvfs2-ha-heartbeat-v2.php#SECTION00083000000000000000">7.3 resources and groups</A>
<LI><A NAME="tex2html48"
  HREF="pvfs2-ha-heartbeat-v2.php#SECTION00084000000000000000">7.4 PVFS2-notify</A>
<LI><A NAME="tex2html49"
  HREF="pvfs2-ha-heartbeat-v2.php#SECTION00085000000000000000">7.5 IPaddr</A>
<LI><A NAME="tex2html50"
  HREF="pvfs2-ha-heartbeat-v2.php#SECTION00086000000000000000">7.6 Filesystem</A>
<LI><A NAME="tex2html51"
  HREF="pvfs2-ha-heartbeat-v2.php#SECTION00087000000000000000">7.7 PVFS2</A>
<LI><A NAME="tex2html52"
  HREF="pvfs2-ha-heartbeat-v2.php#SECTION00088000000000000000">7.8 rsc_location</A>
<LI><A NAME="tex2html53"
  HREF="pvfs2-ha-heartbeat-v2.php#SECTION00089000000000000000">7.9 rsc_order</A>
<LI><A NAME="tex2html54"
  HREF="pvfs2-ha-heartbeat-v2.php#SECTION000810000000000000000">7.10 pvfs2-stonith-plugin</A>
<LI><A NAME="tex2html55"
  HREF="pvfs2-ha-heartbeat-v2.php#SECTION000811000000000000000">7.11 SAN monitoring</A>
</UL>
<BR>
<LI><A NAME="tex2html56"
  HREF="pvfs2-ha-heartbeat-v2.php#SECTION00090000000000000000">8 Starting Heartbeat</A>
<LI><A NAME="tex2html57"
  HREF="pvfs2-ha-heartbeat-v2.php#SECTION000100000000000000000">9 Mounting the file system</A>
<LI><A NAME="tex2html58"
  HREF="pvfs2-ha-heartbeat-v2.php#SECTION000110000000000000000">10 What happens during failover</A>
<LI><A NAME="tex2html59"
  HREF="pvfs2-ha-heartbeat-v2.php#SECTION000120000000000000000">11 Controlling Heartbeat</A>
<LI><A NAME="tex2html60"
  HREF="pvfs2-ha-heartbeat-v2.php#SECTION000130000000000000000">About this document ...</A>
</UL>
<!--End of Table of Contents-->
<P>

<P>

<H1><A NAME="SECTION00020000000000000000">
1 Introduction</A>
</H1>

<P>
This document describes how to configure PVFS2 for high availability
using Heartbeat version 2.x from www.linux-ha.org.  See pvfs2-ha.tex for
documentation on how to configure PVFS2 for high availability using
Heartbeat version 1.x.

<P>
Heartbeat 2.x offers several improvements.  First of all, it allows for
an arbitrary cluster size.  The servers do not have to be paired up for
failover.  For example, if you configure 16 servers and one of them
fails, then any of the remaining 15 can serve as the failover machine.

<P>
Secondly, Heartbeat 2.x supports monitoring of resources.  Examples of
resources that you may want to actively monitor include the PVFS2 server
daemon, the IP interface, and connectivity to storage hardware.

<P>
Finally, Heartbeat 2.x includes a configuration mechanism to express
dependencies between resources.  This can be used to
express a preference for where certain servers run within the cluster,
or to enforce that resources need to be started or stopped in a specific
order.

<P>
This document describes how to set up PVFS2 for high availability with
an arbitrary number of active servers and an arbitrary number of passive spare
nodes.  Spare nodes are not required unless you wish to avoid
performance degradation upon failure.  As configured in this document,
PVFS2 will be able to tolerate <!-- MATH
 $\lceil ((N/2)-1) \rceil$
 -->
<IMG
 WIDTH="109" HEIGHT="34" ALIGN="MIDDLE" BORDER="0"
 SRC="img1.png"
 ALT="$\lceil ((N/2)-1) \rceil$"> node failures,
where N is the number of nodes present in the Heartbeat cluster
including spares.  Over half of the nodes
must be available in order to reach a quorum and decide if another node has
failed.

<P>
No modifications of PVFS2 are required.  Example scripts referenced in
this document are available in the <TT>examples/heartbeat</TT> directory of
the PVFS2 source tree.

<P>

<H1><A NAME="SECTION00030000000000000000">
2 Requirements</A>
</H1>

<P>

<H2><A NAME="SECTION00031000000000000000">
2.1 Hardware</A>
</H2>

<P>

<H3><A NAME="SECTION00031100000000000000">
2.1.1 Nodes</A>
</H3>

<P>
Any number of nodes may be configured, although you need at least 3 in
order to tolerate a failure.  See the explanation in the introduction of
this document.  You may also use any number of spare nodes.  A spare
node is a node that does not run any services until a failover occurs.
If you have one or more spares, then they will be selected first to run
resources in a failover situation.  If you have no spares (or all spares
are exhausted), then at least one node will have to run two services
simultaneously, which may degrade performance.

<P>
The examples in this document will use 4 active nodes and one spare
node.

<P>

<H3><A NAME="SECTION00031200000000000000">
2.1.2 Storage</A>
</H3>

<P>
The specific type of storage hardware is not important, but it must be
possible to allocate a separate block device to each server, and all
servers must be capable of accessing all block devices.

<P>
One way of achieving this is by using a SAN.  In the examples used in
this document, the SAN has been divided into 4 LUNs.  Each of the 5
servers in the cluster is capable of mounting all 4 LUNs.  However, the
same LUN should never be mounted on two nodes simultaneously.  This
document assumes that each block device is formatted using ext3.
The Heartbeat software will insure that a given LUN is mounted in only
one location at a time.

<P>
It is also important that the device naming be consistent across all
nodes.  For example, if node1 mounts /dev/fooa, then it should see the
same data as if node2 were to mount /dev/fooa.  Likewise for /dev/foob,
etc.

<P>

<H3><A NAME="SECTION00031300000000000000">
2.1.3 Stonith</A>
</H3>

<P>
Heartbeat needs some mechanism to fence or stonith a failed node.  One
straightforward way to do this is to connect each server node to a
network controllable power strip.  That will allow any given server to
send a command over the network to power off another server.

<P>
It is possible to configure PVFS2 and Heartbeat without a power control
device.  However, if you deploy this configuration for any purpose other
than evaluation, then you run a very serious risk of data
corruption.   Without stonith, there is no way to guarantee that a
failed node has completely shutdown and stopped accessing its
storage device before failing over.

<P>
The example in this document is using an APC switched PDU (which allows
commands to be sent via SNMP or ssh) as the power control device.

<P>

<H2><A NAME="SECTION00032000000000000000">
2.2 Software</A>
</H2>

<P>
This document assumes that you are using Hearbeat version 2.0.8, and
PVFS2 version 2.6.x or greater.  You may also wish to use example
scripts included in the <TT>examples/heartbeat</TT> directory of the PVFS2 source
tree.

<P>

<H2><A NAME="SECTION00033000000000000000">
2.3 Network</A>
</H2>

<P>
There are two special issues regarding the network configuration to be
used with Heartbeat.  First of all, you must allocate a multicast
address to use for communication within the cluster nodes.

<P>
Secondly, you need to allocate an extra IP address and hostname for each
active PVFS2 server.  In the example that this document uses, we must
allocate 4 extra IP addresses, along with 4 hostnames in DNS
for those IP addresses.  In this document, we will refer to these as
``virtual addresses''.  Each active PVFS2 server will be configured
to automatically bring up one of these virtual addresses to use for
communication.  If the node fails, then that IP address is migrated to
another node so that clients will appear to communicate with the same
server regardless of where it fails over to.  It is important that you
not use the primary IP address of each node for this purpose.

<P>
In the example in this document, we use 225.0.0.1 as the multicast
address, node{1-5} as the normal node hostnames, and
virtualnode{1-4} as the virtual hostnames.

<P>

<H1><A NAME="SECTION00040000000000000000">
3 Configuring PVFS2</A>
</H1>

<P>
Download, build, install, and configure PVFS2.  

<P>
There are a few points to consider when configuring PVFS2:

<UL>
<LI>Use the virtual addresses when specifying meta servers and I/O
servers
</LI>
<LI>Synchronize file data on every operation (necessary for consistency on
failover)
</LI>
<LI>Synchronize meta data on every operation (necessary for consistency on
failover)
</LI>
<LI>Use the <TT>TCPBindSpecific</TT> option (this allows multiple daemons to
run on the same node if needed)
</LI>
<LI>Tune retry and timeout values appropriately for your system.  This
may depend on how long it takes for your power control device to safely
shutdown a node.
</LI>
</UL>

<P>
Figure&nbsp;<A HREF="pvfs2-ha-heartbeat-v2.php#fig:pvfs2conf">1</A> shows one example of how to configure PVFS2.
Only the parameters relevant to the Heartbeat scenario are shown.

<P>

<DIV ALIGN="LEFT"><A NAME="fig:pvfs2conf"></A><A NAME="165"></A>
<TABLE>
<CAPTION ALIGN="BOTTOM"><STRONG>Figure 1:</STRONG>
Example <TT>pvfs2-fs.conf</TT> file</CAPTION>
<TR><TD><IMG
 WIDTH="488" HEIGHT="601" BORDER="0"
 SRC="img2.png"
 ALT="\begin{figure}\begin{scriptsize}
\begin{verbatim}&lt;Defaults&gt;
...
ServerJobBMI...
...rmark 1
&lt;/StorageHints&gt;
&lt;/Filesystem&gt;\end{verbatim}\end{scriptsize}\end{figure}"></TD></TR>
</TABLE>
</DIV>

<P>
Download, build, and install Heartbeat following the instructions on
their web site.  No special parameters or options are required.  Do not
start the Heartbeat service.

<P>

<H1><A NAME="SECTION00050000000000000000">
4 Configuring storage</A>
</H1>

<P>
Make sure that there is a block device allocated for each active server
in the file system.  Format each one with ext3.  Do not create a PVFS2
storage space yet, but you can create subdirectories within each file
system if you wish.

<P>
Confirm that each block device can be mounted from every node, and that
the device names are consistent.  Do this one node at a time.  Never mount
the same block device concurrently on two or more nodes.

<P>

<H1><A NAME="SECTION00060000000000000000">
5 Distributing Heartbeat scripts</A>
</H1>

<P>
The scripts that are in the <TT>examples/heartbeat</TT> subdirectory may be
installed to the following suggested locations on each server node:

<UL>
<LI>pvfs2-ha-heartbeat-configure.sh: /usr/bin
</LI>
<LI>apc*: /usr/bin
</LI>
<LI>baytech*: /usr/bin
</LI>
<LI>qla*: /usr/bin
</LI>
<LI>PVFS2: /usr/lib/ocf/resource.d/external/
</LI>
<LI>PVFS2-notify: /usr/lib/ocf/resource.d/external
</LI>
<LI>Filesystem-qla-monitor: /usr/lib/ocf/resource.d/external
</LI>
<LI>pvfs2-stonith-plugin: /usr/lib/stonith/plugins/external
</LI>
</UL>

<P>

<H1><A NAME="SECTION00070000000000000000">
6 Base Heartbeat configuration</A>
</H1>

<P>
This section describes how to configure the basic Heartbeat daemon
parameters, which include an authentication key and a list of nodes that
will participate in the cluster.

<P>
Begin by generating a random sha1 key, which is used to secure
communication between the cluster nodes.  Then run the 
pvfs2-ha-heartbeat-configure.sh script as shown in
figure&nbsp;<A HREF="pvfs2-ha-heartbeat-v2.php#fig:haconf">2</A> on every node (both active and spare).  You
should use your multicast address as described in the network
requirements, your own sha1 key, and a list of
nodes (including spares) that will participate.

<P>

<DIV ALIGN="LEFT"><A NAME="fig:haconf"></A><A NAME="166"></A>
<TABLE>
<CAPTION ALIGN="BOTTOM"><STRONG>Figure 2:</STRONG>
Example <TT>pvfs2-ha-heartbeat-configure.sh</TT> commands</CAPTION>
<TR><TD><IMG
 WIDTH="465" HEIGHT="85" BORDER="0"
 SRC="img3.png"
 ALT="\begin{figure}\begin{scriptsize}
\begin{verbatim}$ dd if=/dev/urandom count=4 ...
...34262 \
node1 node2 node3 node4 node5\end{verbatim}\end{scriptsize}\end{figure}"></TD></TR>
</TABLE>
</DIV>

<P>
You can view the configuration file that this generates in
/etc/ha.d/ha.cf.  An example ha.cf file (with comments) is provided with
the Heartbeat package if you wish to investigate how to add or change any settings.

<P>

<H1><A NAME="SECTION00080000000000000000">
7 CIB configuration</A>
</H1>

<P>
<TT>Cluster Information Base</TT> (CIB) is the the mechanism that
Heartbeat 2.x uses to store information about the resources that are 
configured for high availability.  The configuration is stored in an
XML format and automatically synchronized across all of the cluster
nodes.

<P>
It is possible to start the Heartbeat services and then configure the
CIB, but it is simpler to begin with a populated XML file on all nodes.

<P>
<TT>cib.xml.example</TT> provides an example of a fully populated
Heartbeat configuration with 5 nodes and 4 active PVFS2 servers.  It
also includes some optional components for completeness.  Relevant
portions of the XML file are outlined below.

<P>
This file should be modified to reflect your configuration, and then
copied into /var/lib/crm/cib.xml on every node in the cluster (including
spares).

<P>

<H2><A NAME="SECTION00081000000000000000">
7.1 crm_config</A>
</H2>

<P>
The <TT>crm_config</TT> portion of the CIB is used to set global
parameters for Heartbeat.  This includes behavioral settings
(such as how to respond if quorum is lost) as well as tunable parameters
(such as timeout values).

<P>
The options selected in this section should work well as a starting
point, but you may refer to the Heartbeat documentation for more
details.

<P>

<H2><A NAME="SECTION00082000000000000000">
7.2 nodes</A>
</H2>

<P>
The <TT>nodes</TT> section is empty on purpose.  This will be filled in
dynamically by the Heartbeat daemons.

<P>

<H2><A NAME="SECTION00083000000000000000">
7.3 resources and groups</A>
</H2>

<P>
The <TT>resources</TT> section describes all resources that the
Heartbeat software needs to manage for failover purposes.  This includes
IP addresses, SAN mount points, and <TT>pvfs2-server</TT> processes.  The
resources are organized into groups, such as <TT>server0</TT>, to
indicate that certain groups of resources should be treated as a single
unit.  For example, if a node were to fail, you cannot just migrate its
<TT>pvfs2-server</TT> process.  You must also migrate the associated IP address
and SAN mount point at the same time.  Groups also make it easier to
start or stop all associated resources for a node with one unified command.

<P>
In the example <TT>cib.xml</TT>, there are 4 groups (server0 through
server3).  These represent the 4 active PVFS2 servers that will run on
the cluster.

<P>

<H2><A NAME="SECTION00084000000000000000">
7.4 PVFS2-notify</A>
</H2>

<P>
The <TT>PVFS2-notify</TT> resources, such as <TT>server0_notify</TT>, are
used as a mechanism to send alerts when a server process fails over to
another node.  This is provided by the <TT>PVFS2-notify</TT> script in
the examples directory.

<P>
The use of a notify resource is entirely optional and may be omitted.
This particular script is designed to take four parameters:

<UL>
<LI><TT>firsthost</TT>: name of the node that the server group should normally
run on
</LI>
<LI><TT>fsname</TT>: arbitrary name for the PVFS2 file system
</LI>
<LI><TT>conf_dir</TT>: location of notification configuration files
</LI>
<LI><TT>title</TT>: component of the title for the notification
</LI>
</UL>

<P>
The <TT>PVFS2-notify</TT> script serves as an example for how one might
implement a notification mechanism.  However, it is incomplete on its
own.  This example relies on a secondary script called
<TT>fs-instance-alarm.pl</TT> to send the actual notification.  For
example, one could implement a script that sends an email when a failure
occurs.  The <TT>conf_dir</TT> parameter could be passed along to
provide a location to read a configurable list of email addresses from.

<P>
<TT>fs-instance-alarm.pl</TT> is not provided with this example or
documentation.

<P>

<H2><A NAME="SECTION00085000000000000000">
7.5 IPaddr</A>
</H2>

<P>
The <TT>IPaddr</TT> resources, such as <TT>server0_address</TT>, are
used to indicate what virtual IP address should be used with each group.
In this example, all IP addresses are allocated from a private range, but
these should be replaced with IP addresses that are appropriate for use
on your network.  See the network requirements section for more details.

<P>

<H2><A NAME="SECTION00086000000000000000">
7.6 Filesystem</A>
</H2>

<P>
The <TT>Filesystem</TT> resources, such as <TT>server0_fs</TT>, are used to
describe the shared storage block devices that serve as back end storage
for PVFS2.  This is where the PVFS2 storage space for each server will
be created.  In this example, the device names are <TT>/dev/fooa1</TT>
through <TT>/dev/food1</TT>.  They are each mounted on directories such
as <TT>/san_mounta1</TT> through <TT>/san_mountd1</TT>.  Please note
that each device should be mounted on a different mount point to allow
multiple <TT>pvfs2-server</TT> processes to operate on the same node without
collision.

<P>

<H2><A NAME="SECTION00087000000000000000">
7.7 PVFS2</A>
</H2>

<P>
The <TT>PVFS2</TT> resources, such as <TT>server0_daemon</TT>, are used
to describe each <TT>pvfs2-server</TT> process.  This resource is provided by the
PVFS2 script in the examples directory.  The parameters to this resource
are listed below:

<UL>
<LI><TT>fsconfig</TT>: location of PVFS2 fs configuration file
</LI>
<LI><TT>serverconfig</TT>: location of PVFS2 server configuration file
</LI>
<LI><TT>port</TT>: TCP/IP port that the server will listen on (must match server
configuration file)
</LI>
<LI><TT>ip</TT>: IP address that the server will listen on (must match both the file
system configuration file and the IPAddr resource)
</LI>
<LI><TT>pidfile</TT>: Location where a pid file can be written
</LI>
</UL>

<P>
Also notice that there is a monitor operation associated with the PVFS2
resource.  This will cause the <TT>pvfs2-check-server</TT> utility to be triggered
periodically to make sure that the <TT>pvfs2-server</TT> process is not only
running, but is correctly responding to PVFS2 protocol requests.  This
allows problems such as hung <TT>pvfs2-server</TT> processes to be treated as
failure conditions.

<P>
Please note that the PVFS2 script provided in the examples will attempt
to create a storage space for each server if it is not already present.

<P>

<H2><A NAME="SECTION00088000000000000000">
7.8 rsc_location</A>
</H2>

<P>
The <TT>rsc_location</TT> constraints, such as <TT>run_server0</TT>,
are used to express a preference for where each resource group should
run (if possible).  It may be useful for administrative purposes to have
the first server group default to run on the first node of your cluster,
etc.

<P>

<H2><A NAME="SECTION00089000000000000000">
7.9 rsc_order</A>
</H2>

<P>
The <TT>rsc_order</TT> constraints, such as
<TT>server0_order_start_fs</TT> can be used to dictate the order in
which resources must be started or stopped.  The resources are already
organized into groups, but without ordering constraints, the resources
within a group may be started in any order relative to each other.
These constraints are necessary because a <TT>pvfs2-server</TT> process will not
start properly if the IP address that it should listen on and the shared
storage that it should use are not available yet.

<P>

<H2><A NAME="SECTION000810000000000000000">
7.10 pvfs2-stonith-plugin</A>
</H2>

<P>
The <TT>pvfs2-stonith-plugin</TT> resource is an example of how to
configure a stonith device for use in Heartbeat.  See the Heartbeat
documentation for a list of officially supported devices.

<P>
In this example, the stonith device is setup as a clone, which means
that there are N identical copies of the resource (one per node).  This
allows any node in the cluster to quickly send a stonith command if
needed.

<P>
The <TT>pvfs2-stonith-plugin</TT> is provided by a script in the
examples directories.  It requires a parameter to specify the file
system name, and a parameter to specify a configuration directory.  This
plugin is not complete by itself, however.  It relies on three scripts
to actually perform the stonith commands:

<UL>
<LI><TT>fs-power-control.pl</TT>: used to send commands to control power to a
node
</LI>
<LI><TT>fs-power-gethosts.pl</TT>: used to print a list of nodes that can be
controlled with this device
</LI>
<LI><TT>fs-power-monitor.pl</TT>: used to monitor the stonith device and
confirm that is available
</LI>
</UL>

<P>
These three stonith scripts are not provided with these examples.  They
may need to be specifically implemented for your environment.  As an alternative,
you can simply use one of the standard stonith devices that are
supported by Heartbeat (see Heartbeat documentation for details).

<P>
The following scripts provide lower level examples of how to control an APC power
strip (via SNMP or SSH) or a Baytech power strip (via SSH):

<UL>
<LI><TT>apc-switched-pdu-hybrid-control.pl</TT>
</LI>
<LI><TT>apc-switched-pdu-hybrid-monitor.pl</TT>
</LI>
<LI><TT>baytech-mgmt-control.pl</TT>
</LI>
<LI><TT>baytech-mgmt-monitor.pl</TT>
</LI>
</UL>

<P>
One approach to implementing power control would be to use the
pvfs2-stonith-plugin device script and write
<TT>fs-power{control/monitor/gethosts}</TT> scripts that can parse
configuration files describing your cluster and send appropriate
commands to the above provided APC and Baytech control scripts.

<P>

<H2><A NAME="SECTION000811000000000000000">
7.11 SAN monitoring</A>
</H2>

<P>
The example CIB configuration does not use this feature, but an
additional resource script has been included that modifies the
<TT>Filesystem</TT> resource to allow it to monitor SAN connectivity.  This
script is called <TT>Filesystem-qla-monitor</TT>.  It requires that the
nodes use QLogic fibre channel adapters and EMC PowerPath
software for SAN connectivity.  If this configuration is available, then this script can
issue appropriate PowerPath commands periodically to confirm that there
is connectivity between each node and its block device.

<P>

<H1><A NAME="SECTION00090000000000000000">
8 Starting Heartbeat</A>
</H1>

<P>
Once the CIB file is completed and installed in the correct location,
then the Heartbeat services can be started on every node with the
command in figure&nbsp;<A HREF="pvfs2-ha-heartbeat-v2.php#fig:start">3</A>.  The <TT>crm_mon</TT> command, when
run with the arguments shown, will provide a periodically updated view
of the state of each resource configured within Heartbeat.  Check
<TT>/var/log/messages</TT> if any of the groups fail to start.

<P>

<DIV ALIGN="LEFT"><A NAME="fig:start"></A><A NAME="136"></A>
<TABLE>
<CAPTION ALIGN="BOTTOM"><STRONG>Figure 3:</STRONG>
Starting Heartbeat services</CAPTION>
<TR><TD><IMG
 WIDTH="342" HEIGHT="41" BORDER="0"
 SRC="img4.png"
 ALT="\begin{figure}\begin{scriptsize}
\begin{verbatim}$ /etc/init.d/heartbeat start...
...eartbeat services started
$ crm_mon -r\end{verbatim}\end{scriptsize}\end{figure}"></TD></TR>
</TABLE>
</DIV>

<P>

<H1><A NAME="SECTION000100000000000000000">
9 Mounting the file system</A>
</H1>

<P>
Mounting PVFS2 with high availability is no different than mounting a
normal PVFS2 file system, except that you must use the virtual hostname
for the PVFS2 server rather than the primary hostname of the node.
Figure&nbsp;<A HREF="pvfs2-ha-heartbeat-v2.php#fig:mount">4</A> provides an example.

<P>

<DIV ALIGN="LEFT"><A NAME="fig:mount"></A><A NAME="146"></A>
<TABLE>
<CAPTION ALIGN="BOTTOM"><STRONG>Figure 4:</STRONG>
Mounting PVFS2 file system</CAPTION>
<TR><TD><IMG
 WIDTH="456" HEIGHT="12" BORDER="0"
 SRC="img5.png"
 ALT="\begin{figure}\begin{scriptsize}
\begin{verbatim}$ mount -t pvfs2 tcp://virtualnode1:3334/pvfs2-fs /mnt/pvfs2\end{verbatim}\end{scriptsize}\end{figure}"></TD></TR>
</TABLE>
</DIV>

<P>

<H1><A NAME="SECTION000110000000000000000">
10 What happens during failover</A>
</H1>

<P>
The following example illustrates the steps that occur when a node fails:

<P>

<OL>
<LI>Node2 (which is running a <TT>pvfs2-server</TT> on the virtualnode2 IP
address) suffers a failure
</LI>
<LI>Client node begins timeout/retry cycle
</LI>
<LI>Heartbeat services running on remaining servers notice that node2
is not responding
</LI>
<LI>After a timeout has elapsed, remaining servers reach a quorum and
vote to treat node2 as a failed node
</LI>
<LI>Node1 sends a stonith command to reset node2
</LI>
<LI>Node2 either reboots or remains powered off (depending on nature
of failure)
</LI>
<LI>Once stonith command succeeds, node5 is selected to replace it
</LI>
<LI>The virtualnode2 IP address, mount point, and
<TT>pvfs2-server</TT> service
are started on node5
</LI>
<LI>Client node retry eventually succeeds, but now the network
traffic is routed to node5
</LI>
</OL>

<P>

<H1><A NAME="SECTION000120000000000000000">
11 Controlling Heartbeat</A>
</H1>

<P>
The Heartbeat software comes with a wide variety of tools for managing
resources.  The following are a few useful examples:

<UL>
<LI><TT>cibadmin -Q</TT>: Display the current CIB information
</LI>
<LI><TT>crm_mon -r -1</TT>: Display the current resource status
</LI>
<LI><TT>crm_standby</TT>: Used to manually take a node in an out of
standby mode.  This can be used to take a node offline for maintenance
without a true failure event.
</LI>
<LI><TT>crm_resource</TT>: Modify resource information.  For example,
<TT>crm_resource -r server0 -p target_role -v stopped</TT> will stop a
particular resource group.
</LI>
<LI><TT>crm_verify</TT>: can be used to confirm if the CIB
information is valid and consistent
</LI>
</UL>

<P>

<H1><A NAME="SECTION000130000000000000000">
About this document ...</A>
</H1>
 <STRONG>PVFS2 High-Availability Clustering using Heartbeat 2.0</STRONG><P>
This document was generated using the
<A HREF="http://www.latex2html.org/"><STRONG>LaTeX</STRONG>2<tt>HTML</tt></A> translator Version 2002 (1.62)
<P>
Copyright &#169; 1993, 1994, 1995, 1996,
<A HREF="http://cbl.leeds.ac.uk/nikos/personal.html">Nikos Drakos</A>, 
Computer Based Learning Unit, University of Leeds.
<BR>
Copyright &#169; 1997, 1998, 1999,
<A HREF="http://www.maths.mq.edu.au/~ross/">Ross Moore</A>, 
Mathematics Department, Macquarie University, Sydney.
<P>
The command line arguments were: <BR>
 <STRONG>latex2html</STRONG> <TT>-split 0 -show_section_numbers -nonavigation -init_file /tmp/pvfs-2.7.1/doc/latex2html-init pvfs2-ha-heartbeat-v2.tex</TT>
<P>
The translation was initiated by Samuel Lang (ANL) on 2008-04-14
<BR><HR>
<ADDRESS>
Samuel Lang (ANL)
2008-04-14
</ADDRESS></table></table></table><?include("../../../../bottom.php"); ?>
</BODY>
</HTML>
