<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 3.2 Final//EN">

<!--Converted with jLaTeX2HTML 2002 (1.62) JA patch-1.4
patched version by:  Kenshi Muto, Debian Project.
LaTeX2HTML 2002 (1.62),
original version by:  Nikos Drakos, CBLU, University of Leeds
* revised and updated by:  Marcus Hennecke, Ross Moore, Herb Swan
* with significant contributions from:
  Jens Lippmann, Marek Rouchal, Martin Wilck and others -->
<HTML>
<HEAD>
<TITLE>PVFS Tuning</TITLE>
<META NAME="description" CONTENT="PVFS Tuning">
<META NAME="keywords" CONTENT="pvfs2-tuning">
<META NAME="resource-type" CONTENT="document">
<META NAME="distribution" CONTENT="global">

<META HTTP-EQUIV="Content-Type" CONTENT="text/html; charset=iso-8859-1">
<META NAME="Generator" CONTENT="jLaTeX2HTML v2002 JA patch-1.4">
<META HTTP-EQUIV="Content-Style-Type" CONTENT="text/css">

<LINK REL="STYLESHEET" HREF="pvfs2-tuning.css">

<? include("../../../../header.php"); ?></HEAD>

<?include("../../../..//top.php"); ?> <body id="documentation">



<table width="95%" class="tabletype1" cellpadding="0" cellspacing="0" align="left">
<tr>
<td>
<table width="100%" cellspacing="0" cellpadding="1">
<tr>                                                          
<td class="nav_white" width="70%" valign="top">               
<br>

<table cellspacing="0" cellpadding="1" align="left" width="70%">
<tr>
<td width="80%" valign="top">
<H1 ALIGN="LEFT">PVFS Tuning</H1>
<P ALIGN="LEFT"><STRONG>PVFS Development Team </STRONG></P>

<P>
<BR>

<H2><A NAME="SECTION00010000000000000000">
Contents</A>
</H2>
<!--Table of Contents-->

<UL>
<LI><A NAME="tex2html32"
  HREF="pvfs2-tuning.php">1 Introduction</A>
<LI><A NAME="tex2html33"
  HREF="pvfs2-tuning.php#SECTION00030000000000000000">2 Cluster Partitioning</A>
<LI><A NAME="tex2html34"
  HREF="pvfs2-tuning.php#SECTION00040000000000000000">3 Storage</A>
<UL>
<LI><A NAME="tex2html35"
  HREF="pvfs2-tuning.php#SECTION00041000000000000000">3.1 Server Configuration</A>
<LI><A NAME="tex2html36"
  HREF="pvfs2-tuning.php#SECTION00042000000000000000">3.2 Local File System</A>
<LI><A NAME="tex2html37"
  HREF="pvfs2-tuning.php#SECTION00043000000000000000">3.3 Disk Synchronization</A>
<LI><A NAME="tex2html38"
  HREF="pvfs2-tuning.php#SECTION00044000000000000000">3.4 Metadata</A>
<LI><A NAME="tex2html39"
  HREF="pvfs2-tuning.php#SECTION00045000000000000000">3.5 Data</A>
</UL>
<BR>
<LI><A NAME="tex2html40"
  HREF="pvfs2-tuning.php#SECTION00050000000000000000">4 Networks</A>
<UL>
<LI><A NAME="tex2html41"
  HREF="pvfs2-tuning.php#SECTION00051000000000000000">4.1 Network Independent</A>
<LI><A NAME="tex2html42"
  HREF="pvfs2-tuning.php#SECTION00052000000000000000">4.2 TCP</A>
<LI><A NAME="tex2html43"
  HREF="pvfs2-tuning.php#SECTION00053000000000000000">4.3 Infiniband</A>
<LI><A NAME="tex2html44"
  HREF="pvfs2-tuning.php#SECTION00054000000000000000">4.4 Myrinet Express</A>
</UL>
<BR>
<LI><A NAME="tex2html45"
  HREF="pvfs2-tuning.php#SECTION00060000000000000000">5 VFS Layer</A>
<UL>
<LI><A NAME="tex2html46"
  HREF="pvfs2-tuning.php#SECTION00061000000000000000">5.1 Maximum I/O Size</A>
<LI><A NAME="tex2html47"
  HREF="pvfs2-tuning.php#SECTION00062000000000000000">5.2 Workload Specifics</A>
<LI><A NAME="tex2html48"
  HREF="pvfs2-tuning.php#SECTION00063000000000000000">5.3 Extended Attributes</A>
</UL>
<BR>
<LI><A NAME="tex2html49"
  HREF="pvfs2-tuning.php#SECTION00070000000000000000">6 Workloads</A>
<UL>
<LI><A NAME="tex2html50"
  HREF="pvfs2-tuning.php#SECTION00071000000000000000">6.1 Small files</A>
<LI><A NAME="tex2html51"
  HREF="pvfs2-tuning.php#SECTION00072000000000000000">6.2 Large Files</A>
<LI><A NAME="tex2html52"
  HREF="pvfs2-tuning.php#SECTION00073000000000000000">6.3 Concurrent IO</A>
</UL>
<BR>
<LI><A NAME="tex2html53"
  HREF="pvfs2-tuning.php#SECTION00080000000000000000">7 Benchmarking</A>
<LI><A NAME="tex2html54"
  HREF="pvfs2-tuning.php#SECTION00090000000000000000">8 References</A>
<LI><A NAME="tex2html55"
  HREF="pvfs2-tuning.php#SECTION000100000000000000000">About this document ...</A>
</UL>
<!--End of Table of Contents-->

<P>

<H1><A NAME="SECTION00020000000000000000">
1 Introduction</A>
</H1>

<P>
The default settings for PVFS (those provided and in the source code
and added to the config files by <TT>pvfs2-genconfig</TT>)
provide good performance on most systems and for a wide variety of workloads.
This document describes system level and PVFS specific parameters 
that can be tuned to improve
performance on specific hardware, or for specific workloads and usage
scenarios.  

<P>
In general performance tuning should begin with the available hardware
and system software, to maximize the bandwidth of the network and
transfer rates of the storage hardware.  From there, PVFS server
parameters can be tuned to improve performance of the
entire system, especially
if specific usage scenarios are targetted.  Finally, file system 
extended attributes and hints can be tweaked by different users to
improve individual performance within a system with varying workloads.

<P>
Some (especially system level) parameters can be tuned to provide better
performance without sacrificing another property of the system.  
Tuning some parameters though, may have a direct effect on the
performance of other usage scenarios, or some other property of the
system (such as durability).  
Our discussion of performance tuning will include the tradeoffs
that must be made during the tuning process, but the final decisions are best
made by the administrators to determine the optimal 
setup that meets the needs of their users.

<P>

<H1><A NAME="SECTION00030000000000000000">
2 Cluster Partitioning</A>
</H1>

<P>
For users that have one use case, and a generic cluster, what's the best
partition of compute/IO nodes?  Is this section needed?

<P>

<H1><A NAME="SECTION00040000000000000000">
3 Storage</A>
</H1>

<P>

<H2><A NAME="SECTION00041000000000000000">
3.1 Server Configuration</A>
</H2>

<P>
How many IO servers? <A NAME="tex2html1"
  HREF="#foot14"><SUP>1</SUP></A>How many MD servers?
Should IO and MD servers be shared?

<P>

<H2><A NAME="SECTION00042000000000000000">
3.2 Local File System</A>
</H2>

<P>

<UL>
<LI>ext3
</LI>
<LI>xfs
</LI>
</UL>

<P>

<H2><A NAME="SECTION00043000000000000000">
3.3 Disk Synchronization</A>
</H2>

<P>
The easiest way to see an improvement in performance is to set the
<TT>TroveSyncMeta</TT> and <TT>TroveSyncData</TT> attributes to ``no''
in the <TT>&lt;StorageHints&gt;</TT> section.  If those attributes are set to
``no'' then Trove will read and write data from a cache and not the
underlying file.  Performance will increase greatly, but if the server
dies at some point, you could lose data.  At this point in PVFS2
development, server crashes are rare outside of hardware failures.
PVFS2 developers should probably leave these settings to ``yes''.  If
PVFS2 hosts the only copy of your data, leave these settings to ``yes''.
Otherwise, give ``no'' a shot.

<P>
Sync or not, metadata, data
  coalescing

<P>
distributed metadata

<P>

<H2><A NAME="SECTION00044000000000000000">
3.4 Metadata</A>
</H2>

<H3><A NAME="SECTION00044100000000000000">
3.4.1 Coalescing</A>
</H3>

<P>

<H2><A NAME="SECTION00045000000000000000">
3.5 Data</A>
</H2>

<P>

<H1><A NAME="SECTION00050000000000000000">
4 Networks</A>
</H1>

<P>

<H2><A NAME="SECTION00051000000000000000">
4.1 Network Independent</A>
</H2>

<P>

<OL>
<LI>Unexpected message size
</LI>
<LI>Flow Parameters
</LI>
</OL>

<P>

<UL>
<LI>buffer size
</LI>
<LI>count
</LI>
</UL>

<P>

<H2><A NAME="SECTION00052000000000000000">
4.2 TCP</A>
</H2>

<P>

<H3><A NAME="SECTION00052100000000000000">
4.2.1 Kernel Parameters</A>
</H3>

<H3><A NAME="SECTION00052200000000000000">
4.2.2 Socket Buffer Sizes</A>
</H3>

<H3><A NAME="SECTION00052300000000000000">
4.2.3 Listening Backlog (?)</A>
</H3>

<P>

<H2><A NAME="SECTION00053000000000000000">
4.3 Infiniband</A>
</H2>

<H2><A NAME="SECTION00054000000000000000">
4.4 Myrinet Express</A>
</H2>

<P>

<H1><A NAME="SECTION00060000000000000000">
5 VFS Layer</A>
</H1>

<P>

<H2><A NAME="SECTION00061000000000000000">
5.1 Maximum I/O Size</A>
</H2>

<P>

<H2><A NAME="SECTION00062000000000000000">
5.2 Workload Specifics</A>
</H2>

<P>

<H2><A NAME="SECTION00063000000000000000">
5.3 Extended Attributes</A>
</H2>

<P>

<H3><A NAME="SECTION00063100000000000000">
5.3.1 Directory Hints</A>
</H3>

<P>

<UL>
<LI>Number of Datafiles
</LI>
<LI>Stripe Size
</LI>
<LI>Distribution
</LI>
</UL>

<P>

<H1><A NAME="SECTION00070000000000000000">
6 Workloads</A>
</H1>

<P>

<H2><A NAME="SECTION00071000000000000000">
6.1 Small files</A>
</H2>

<H2><A NAME="SECTION00072000000000000000">
6.2 Large Files</A>
</H2>

<H2><A NAME="SECTION00073000000000000000">
6.3 Concurrent IO</A>
</H2>

<P>

<H1><A NAME="SECTION00080000000000000000">
7 Benchmarking</A>
</H1>

<P>

<UL>
<LI>mpi-io-test
</LI>
<LI>mpi-md-test
</LI>
</UL>

<P>

<H1><A NAME="SECTION00090000000000000000">
8 References</A>
</H1>

<P>

<H1><A NAME="SECTION000100000000000000000">
About this document ...</A>
</H1>
 <STRONG>PVFS Tuning</STRONG><P>
This document was generated using the
<A HREF="http://www.latex2html.org/"><STRONG>LaTeX</STRONG>2<tt>HTML</tt></A> translator Version 2002 (1.62)
<P>
Copyright &#169; 1993, 1994, 1995, 1996,
<A HREF="http://cbl.leeds.ac.uk/nikos/personal.html">Nikos Drakos</A>, 
Computer Based Learning Unit, University of Leeds.
<BR>
Copyright &#169; 1997, 1998, 1999,
<A HREF="http://www.maths.mq.edu.au/~ross/">Ross Moore</A>, 
Mathematics Department, Macquarie University, Sydney.
<P>
The command line arguments were: <BR>
 <STRONG>latex2html</STRONG> <TT>-split 0 -show_section_numbers -nonavigation -init_file /tmp/pvfs-2.7.1/doc/latex2html-init pvfs2-tuning.tex</TT>
<P>
The translation was initiated by Samuel Lang (ANL) on 2008-04-14
<BR><HR><H4>Footnotes</H4>
<DL>
<DT><A NAME="foot14">... servers?</A><A
 HREF="pvfs2-tuning.php#tex2html1"><SUP>1</SUP></A></DT>
<DD>The FAQ already answers this to some
degree

</DD>
</DL>
<BR><HR>
<ADDRESS>
Samuel Lang (ANL)
2008-04-14
</ADDRESS></table></table></table><?include("../../../../bottom.php"); ?>
</BODY>
</HTML>
